/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

#ifndef INCLUDED_COM_SUN_STAR_UNO_GENFUNC_HXX
#define INCLUDED_COM_SUN_STAR_UNO_GENFUNC_HXX

#include "sal/config.h"

#include <cstddef>

#include "com/sun/star/uno/genfunc.h"
#include "com/sun/star/uno/Any.hxx"
#include "com/sun/star/uno/XInterface.hpp"


namespace com
{
namespace sun
{
namespace star
{
namespace uno
{


inline void SAL_CALL cpp_acquire( void * pCppI )
{
    static_cast< XInterface * >( pCppI )->acquire();
}

inline void SAL_CALL cpp_release( void * pCppI )
{
    static_cast< XInterface * >( pCppI )->release();
}

inline void * SAL_CALL cpp_queryInterface( void * pCppI, typelib_TypeDescriptionReference * pType )
{
    if (pCppI)
    {
        try
        {
            Any aRet( static_cast< XInterface * >( pCppI )->queryInterface(
                * reinterpret_cast< const Type * >( &pType ) ) );
            if (typelib_TypeClass_INTERFACE == aRet.pType->eTypeClass)
            {
                XInterface * pRet = static_cast< XInterface * >( aRet.pReserved );
                aRet.pReserved = NULL;
                return pRet;
            }
        }
        catch (RuntimeException &)
        {
        }
    }
    return NULL;
}

}
}
}
}

#endif

/* vim:set shiftwidth=4 softtabstop=4 expandtab: */
