/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */


#ifndef INCLUDED_CPPUHELPER_BASEMUTEX_HXX
#define INCLUDED_CPPUHELPER_BASEMUTEX_HXX

#include "osl/mutex.hxx"

namespace cppu
{
    /** base class for all classes who want derive from
     cppu::WeakComponentImplHelperXX.

     Implementation classes have first to derive from BaseMutex and then from
     cppu::WeakComponentImplHelperXX to ensure that the BaseMutex is completely
     initialized when the mutex is used to initialize the
     cppu::WeakComponentImplHelperXX
    */
    class SAL_WARN_UNUSED BaseMutex
    {
    protected:
        mutable ::osl::Mutex m_aMutex;
    };
}
#endif // INCLUDED_CPPUHELPER_BASEMUTEX_HXX

/* vim:set shiftwidth=4 softtabstop=4 expandtab: */
